% packages

% install from https://github.com/georgd/EB-Garamond
%\usepackage{fontspec}
%\setmainfont{EBGaramond-Regular}[
%  BoldFont = EBGaramond-Bold,
%  ItalicFont = EBGaramond-Italic,
%  BoldItalicFont = EBGaramond-BoldItalic]
%%\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage[francais,english]{babel}
\babelhyphenation[english]{equip-ped}
\babelhyphenation[english]{com-mu-ni-ca-tor}
%\babelhyphenation[english]{MPI-+-Open-MP-+-X}
\usepackage[dvipsnames]{xcolor}

\usepackage{xspace}
\usepackage{xfrac}
\usepackage[maxbibnames=99]{biblatex}
\usepackage{amssymb}
%natbib
\usepackage{bibentry}
\usepackage{caption}
\usepackage{subcaption}
\usepackage{makecell}
\usepackage{ifthen}
\usepackage{marginnote}

\usepackage{hyperref}

\usepackage{float}
%\usepackage{algpseudocode}
\usepackage{algorithmic}
%\algdef{SE}[SUBALG]{Indent}{EndIndent}{}{\algorithmicend\ }%
%\algtext*{Indent}
%\algtext*{EndIndent}

\usepackage{xargs}
\usepackage[colorinlistoftodos,prependcaption,textsize=tiny]{todonotes}
\usepackage[pdftex]{changebar}
\newcommandx{\unsure}[2][1=]{\todo[linecolor=red,backgroundcolor=red!25,bordercolor=red,#1]{#2}}
\newcommandx{\change}[2][1=]{\todo[linecolor=blue,backgroundcolor=blue!25,bordercolor=blue,#1]{#2}}
\newcommandx{\info}[2][1=]{\todo[linecolor=OliveGreen,backgroundcolor=OliveGreen!25,bordercolor=OliveGreen,#1]{#2}}
\newcommandx{\improvement}[3][1=]{\todo[linecolor=myred,backgroundcolor=myred!25,bordercolor=myred,#1]{#2}\cbcolor{Plum}\cbstart#3\cbend}
\newcommandx{\thiswillnotshow}[2][1=]{\todo[disable,#1]{#2}}
\cbcolor{Plum}


\usepackage{tikz}


\usetikzlibrary{arrows,math,decorations.pathreplacing, positioning}
\usetikzlibrary{backgrounds,calc}
\usetikzlibrary{patterns,patterns.meta}
\usetikzlibrary{intersections}

\definecolor{gray98}{rgb}{0.98,0.98,0.98}
\definecolor{gray20}{rgb}{0.20,0.20,0.20}
\definecolor{gray25}{rgb}{0.25,0.25,0.25}
\definecolor{gray16}{rgb}{0.161,0.161,0.161}
\definecolor{gray60}{rgb}{0.6,0.6,0.6}
\definecolor{gray30}{rgb}{0.3,0.3,0.3}
\definecolor{bgray}{RGB}{248, 248, 248}
\definecolor{mypur}{RGB}{126,47,142}
\definecolor{myred}{RGB}{162,20,47}
\definecolor{myblu}{RGB}{0,114,189}
\definecolor{mygre}{RGB}{119,172,48}
\definecolor{myyel}{RGB}{237,177,32}
\definecolor{myorg}{RGB}{217,83,25}

\newcommand{\pGETRF}{pGETRF\xspace}
\newcommand{\GETRF}{GETRF\xspace}
\newcommand{\pPOTRF}{pPOTRF\xspace}
\newcommand{\POTRF}{POTRF\xspace}
\newcommand{\pGEMM}{pGEMM\xspace}
\newcommand{\GEMM}{GEMM\xspace}
\newcommand{\pSYMM}{pSYMM\xspace}
\newcommand{\SYMM}{SYMM\xspace}
\newcommand{\TRSM}{TRSM\xspace}

%\newcommand{\op}[1]{\texttt{#1}}
\newcommand{\gemm}{\texttt{gemm}\xspace}
\newcommand{\symm}{\texttt{symm}\xspace}
\newcommand{\potrf}{\texttt{potrf}\xspace}
\newcommand{\trsm}{\texttt{trsm}\xspace}
\newcommand{\syrk}{\texttt{syrk}\xspace}

\newcommand{\stfinsert}{\texttt{insert\_task}\xspace}
\newcommand{\stfinserts}{\texttt{insert\_tasks}\xspace}
\newcommand{\stfRW}{\texttt{RW}\xspace}
\newcommand{\stfW}{\texttt{W}\xspace}
\newcommand{\stfR}{\texttt{R}\xspace}
\newcommand{\stfSAME}{\texttt{SAME}\xspace}
\newcommand{\stfRKREDUX}{\texttt{RANK\_REDUX}\xspace}
\newcommand{\stfREDUX}{\texttt{REDUX}\xspace}
\newcommand{\stfONRANK}{\texttt{ON\_RANK}\xspace}


\newcommand{\dg}[1]{\textcolor{mygre}{#1\xspace}}
\newcommand{\dr}[1]{\textcolor{myred}{#1\xspace}}
\newcommand{\db}[1]{\textcolor{myblu}{#1\xspace}}
\newcommand{\dd}[1]{\textcolor{gray!70}{#1\xspace}}
\newcommand{\gn}[1]{\textcolor{gray!110}{#1\xspace}}
\newcommand{\gs}[1]{\textcolor{gray!50}{#1\xspace}}
\newcommand{\gt}[1]{\textcolor{gray!20}{#1\xspace}}
\newcommand{\dk}[1]{\textcolor{black}{#1\xspace}}
\newcommand{\mye}[1]{\textcolor{myyel}{#1}\xspace}
\newcommand{\mgr}[1]{\textcolor{mygre}{#1}\xspace}
\newcommand{\mbl}[1]{\textcolor{myblu}{#1}\xspace}
\newcommand{\mre}[1]{\textcolor{myred}{#1}\xspace}
\newcommand{\mbk}[1]{\textcolor{black}{#1}\xspace}
\newcommand{\mbp}[1]{\textcolor{mypur}{#1}\xspace}
\newcommand{\mor}[1]{\textcolor{myorg}{#1}\xspace}

\newcommand\todoaj[1]{\todo[inline,author=Antoine, color=purple!50, bordercolor=purple]{#1}}
\newcommand\todoab[1]{\todo[inline,author=Alfredo, color=olive!50,  bordercolor=olive]{#1}}
\newcommand\todoag[1]{\todo[inline,author=Abdou,   color=yellow!50, bordercolor=yellow!50]{#1}}
\newcommand{\todoRone}{\todo[inline,author=Reviewer1,   color=green!10, bordercolor=green!80]}
\newcommand{\todoRtwo}{\todo[inline,author=Reviewer2,   color=red!10, bordercolor=red!80]}
\newcommand{\todoRthree}{\todo[inline,author=Reviewer3,   color=blue!10, bordercolor=blue!80]}


% % % % \usepackage[procnames]{listings}
% % % % \lstset{ %
% % % %   backgroundcolor=\color{gray98},   % choose the background color; you must add \usepackage{color} or \usepackage{xcolor}
% % % %   basicstyle=\linespread{1.1}\tt, % \prettysmall    % the size of the fonts that are used for the code
% % % %   breakatwhitespace=false,          % sets if automatic breaks should only happen at whitespace
% % % %   breaklines=true,                  % sets automatic line breaking
% % % %   showlines=true,                   % sets automatic line breaking
% % % %   captionpos=b,                     % sets the caption-position to bottom
% % % %   commentstyle=\color{gray30},      % comment style
% % % %   extendedchars=true,               % lets you use non-ASCII characters; for 8-bits encodings only, does not work with UTF-8
% % % %   frame=single,                     % adds a frame around the code
% % % %   keepspaces=true,                  % keeps spaces in text, useful for keeping indentation of code (possibly needs columns=flexible)
% % % %   keywordstyle=\color{black},       % keyword style
% % % %   procnamestyle=\color{black},      % procedures style
% % % %   language=[95]fortran,             % the language of the code
% % % %   numbers=left,                     % where to put the line-numbers; possible values are (none, left, right)
% % % %   numbersep=5pt,                    % how far the line-numbers are from the code
% % % %   numberstyle=\small\color{gray20}, % the style that is used for the line-numbers
% % % %   rulecolor=\color{gray20},         % if not set, the frame-color may be changed on line-breaks within not-black text (e.g. comments (green here))
% % % %   showspaces=false,                 % show spaces everywhere adding particular underscores; it overrides 'showstringspaces'
% % % %   showstringspaces=false,           % underline spaces within strings only
% % % %   showtabs=false,                   % show tabs within strings adding particular underscores
% % % %   stepnumber=2,                     % the step between two line-numbers. If it's 1, each line will be numbered
% % % %   stringstyle=\color{black},        % string literal style
% % % %   tabsize=2,                        % sets default tabsize to 2 spaces
% % % %   % title=\xspace,                    % show the filename of files included with \lstinputlisting; also try caption instead of title
% % % %   procnamekeys={call},
% % % %   escapeinside={(*}{*)},
% % % %   xleftmargin=15pt,
% % % %   frame=l,
% % % %   framesep=4.5mm,
% % % %   framexleftmargin=1.0mm,
% % % %   fillcolor=\color{gray!30},
% % % %   rulecolor=\color{myblu},
% % % %   numberstyle=\normalfont\small\color{black}
% % % % }

%% FIXME Algorithms
%% FIX IEEEtran does not allow algorithm2e because of floating whatever
% \usepackage[ruled,noend,nofillcomment,linesnumbered]{algorithm2e}
% \SetAlFnt{\small}
% \SetAlCapFnt{\small}
% \SetAlCapNameFnt{\small}
% \SetKwComment{comment}{}{}
% \newcommand\commentfont[1]{\textit{\textcolor{blue}{#1}}}
% \SetCommentSty{commentfont}
% \DontPrintSemicolon
% \newcommand{\lIfElse}[3]{\lIf{#1}{#2 \textbf{else}~#3}} # does not work with
% IEEtran
% \SetArgSty{relax}



\usepackage{array}
\usepackage{multirow}
\usepackage{mathtools}
\usepackage{amsmath}
\usepackage[normalem]{ulem}

% commands
\newcommand{\qrm}{\texttt{qr\_mumps}\xspace}
% \newenvironment{ab}{\begin{quote}\color{purple}\small\sf{$\rhd$~AB~}}{\end{quote}}
% \newenvironment{aj}{\begin{quote}\color{mygre}\small\sf{$\rhd$~AJ~}}{\end{quote}}
% \newenvironment{ea}{\begin{quote}\color{blue}\small\sf{$\rhd$~EA~}}{\end{quote}}
\newenvironment{ab}{\begin{quote}\color{purple}\small\sf{$\rhd$~AB~}}{\end{quote}}
\newenvironment{aj}{\begin{quote}\color{mygre}\small\sf{$\rhd$~AJ~}}{\end{quote}}
\newenvironment{ea}{\begin{quote}\color{blue}\small\sf{$\rhd$~EA~}}{\end{quote}}
\newcommand{\otoprule}{\midrule[\heavyrulewidth]}
\newcommand{\starpu}{{StarPU}\xspace}
\newcommand{\prettysmall}{\fontsize{6.7}{6.7}\selectfont}

\tikzset{task/.style n args={1}{
   minimum size=0.3cm,circle,anchor=center,draw=#1,fill=#1!40,thick}
}

% Remove fields like url, doi, isbn, etc.
\AtEveryBibitem{%
  \clearfield{url}%
  \clearfield{doi}%
  \clearfield{isbn}%
  \clearfield{issn}%
  \clearfield{eprint}%
  \clearfield{month}%
  \clearfield{day}%
}
